package com.example.mmad.testapp.service;

import com.example.mmad.testapp.entity.PersonEntity;
import com.example.mmad.testapp.mapper.PersonMapper;
import com.example.mmad.testapp.model.PersonModel;
import com.example.mmad.testapp.repository.PersonRepository;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class PersonService {

    private final PersonRepository personRepository;

    public PersonService(PersonRepository personRepository) {
        this.personRepository = personRepository;
    }

    @Transactional(rollbackFor = Exception.class)
    public PersonModel createPerson(PersonModel person) {
        PersonEntity entity = PersonMapper.get().modelToEntity(person);
        personRepository.save(entity);
        return PersonMapper.get().entityToModel(entity);
    }

    @Transactional(readOnly = true)
    public PersonModel getPerson(Long id) {
        return PersonMapper.get().entityToModel(personRepository.gerPersonById(id));
    }

    @Transactional(rollbackFor = Exception.class)
    public void deletePerson(Long id) {
        personRepository.deleteById(id);
    }

    @Transactional(rollbackFor = Exception.class)
    public PersonModel updatePerson(PersonModel model) {
        personRepository.updatePersonById(model.getFirstName(), model.getLastName(), model.getId());
        return PersonMapper.get().entityToModel(personRepository.gerPersonById(model.getId()));
    }
}
